# dmd.builtin

Implement CTFE for intrinsic (`builtin`) functions.

#### Discussion

Currently includes functions from `std.math`, `core.math` and `core.bitop`.

#### Authors

Walter Bright

#### License

Boost License 1.0

Source: builtin.d

Documentation: https://dlang.org/phobos/dmd_builtin.html

Coverage: https://codecov.io/gh/dlang/dmd/src/master/src/dmd/builtin.d

- `isBuiltin`

  #### Declaration

  `BUILTIN `isBuiltin`(FuncDeclaration `fd`);`

  Determine if function is a builtin one that we can evaluate at compile time.

- `eval_builtin`

  #### Declaration

  `Expression `eval_builtin`(const ref Loc `loc`, FuncDeclaration `fd`, Expressions* `arguments`);`

  Evaluate builtin function. Return result; NULL if cannot evaluate it.